const {Router} = require("express");

module.exports = (parentRouter, path, modifiable, bodyName, save, authHandler) => {
    const router = Router();
    
    router.get("/", (req, res) => res.json(req.listData));
    router.get("/list", (req, res) => res.json(!Array.isArray(req.listData) ? Object.keys(req.listData) : req.listData));
    router.get('/random', (req, res) => res.json(!Array.isArray(req.listData) ? Object.keys(req.listData)[Math.floor(Math.random() * Object.keys(req.listData).length)] : req.listData[Math.floor(Math.random() * req.listData.length)]));
    //TODO search
    
    if (modifiable) {
        const camelBodyName = require('./bodycase')(bodyName);
        const add = async (req, res) => {
            if (!req.body[bodyName]) {return await res.status(400).send(`Missing body param "${camelBodyName}".`);}
            if (typeof req.body[bodyName] !== 'string') {return await res.status(400).send('You did not provide a string!');}
            req.listData.push(req.body[camelBodyName]);
            return await save(req, res, req.listData, req.body[camelBodyName]) || await res.json(req.listData);
        }
        router.post('/add', authHandler, add);
        router.post('/', authHandler, add);
        router.post('/clear', authHandler, async (req, res) => {
            req.listData = [];
            return await save(req, res, req.listData) || res.json(req.listData);
        });
        router.delete('/remove', authHandler, async (req, res) => {
            if (!req.body[camelBodyName]) {return res.status(400).send(`Missing body param "${camelBodyName}".`);}
            let index = req.listData.indexOf(req.body[camelBodyName]);
            if (index === -1) {return res.status(400).send("The server was unable to find an item matching the specified criteria.");}
            let length = req.listData.length;

            if (req.listData.length === 1 && req.listData[0] === req.body[camelBodyName]) {req.listData = [];}
            else {req.listData.splice(index, 1);}

            return req.listData.length === length ? res.status(500).send("For some reason, that couldn't be removed.") : await save(req, res, req.listData) || res.json(req.listData);
        });
    }

    router.location = path;

    return router;
};